<?php if (!defined('PmWiki')) exit();

define(PHPINC_BINDIR, 'phpinc/');
define(PHPINC_PERMPAGE, 'Site.PhpIncPermissions');

Markup('phpinc', '_begin', "/\\(:phpinc ([\\w\\-\\/]+)(| .*?):\\)/e",
  "phpinc_capture(PSS('$1'), PSS('$2'))");

$GLOBALS['phpinc_allow_exec'] = false;  # false = not yet initialized

# Begrenzer fr 4. Parameter mssen " sein, sonst schlgt PSS() fehl.

function phpinc_capture($phpinc_script, $phpinc_params)
{
  $phpinc_caller = ResolvePageName($GLOBALS['pagename']);
  $phpinc_incfn = phpinc_find_file($phpinc_script . '.php');
  if ($phpinc_incfn === false)
    { return "[error@phpinc@$phpinc_caller: 404 plugin not found: $phpinc_script]"; }

  if (!phpinc_check_execauth($phpinc_caller, $phpinc_script))
  {
    return ("[error@phpinc@$phpinc_caller: 403 execution [[" . PHPINC_PERMPAGE
      . "?action=edit|denied]]: $phpinc_script]");
  }

  $phpinc_params = ParseArgs($phpinc_params);

  $status = '';
  ob_start();
  try
  {
    $status = include($phpinc_incfn);
    if (!is_string($status)) { $status = ''; }
  }
  catch (Exception $err)
  {
    echo "\n!!! Runtime Error: ", $err->getMessage(), "\n";
  }
  $content = ob_get_contents() . $status;
  ob_end_clean();

  # defuse output against infinite loops (only one Keep() token for all)
  $content = str_replace('(:phpinc', Keep('(:phpinc'), $content);

  return $content;
}


function phpinc_check_execauth($caller, $script)
{
  global $phpinc_allow_exec;

  if ($phpinc_allow_exec === false)  # when called the first time, read permissions
  {
    $perms = ReadPage(PHPINC_PERMPAGE);
    $perms = (isset($perms['text']) ? explode("\n", (string)$perms['text']) : array());

    $phpinc_allow_exec = array('*' => array());
    $wikipage = '';

    foreach ($perms as $perm)
    {
      $scripts = explode(' ', trim($perm));
      $wikipage = array_shift($scripts);
      if (preg_match('!^:([^\s\.:]*\.[^\s\.:]*|\*):$!', $wikipage, $treffer))
      {
        $phpinc_allow_exec[$treffer[1]] = $scripts;
      }
    }
  }


  if (in_array($script, $phpinc_allow_exec['*'])) { return true; }

  if (isset($phpinc_allow_exec[$caller]))
  {
    if (in_array($script, $phpinc_allow_exec[$caller])) { return true; }
  }

  list($group) = explode('.', $caller);
  if (isset($phpinc_allow_exec[$group . '.*']))
  {
    if (in_array($script, $phpinc_allow_exec[$group . '.*'])) { return true; }
  }

  return false;
}


function phpinc_use_lib($fn)
{
  $libfn = phpinc_find_file($fn);
  if ($libfn === false)
  {
    die('[error@phpinc@' . $GLOBALS['pagename'] . ': 404 lib not found: ' . $fn . ']');
  }
  else
  {
    require_once $libfn;
  }
}


function phpinc_find_file($fn)
{
  $local_fn = PHPINC_BINDIR . $fn;
  if (file_exists($local_fn)) { return $local_fn; }

  $farm_fn = $GLOBALS['FarmD'] . '/' . $local_fn;
  if (file_exists($farm_fn)) { return $farm_fn; }

  return false;
}